/*
 * FuenteCC.java
 *
 * Created on 3 de mayo de 2007, 11:30 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
//package componenteselectricos;
import java.awt.*;
import java.awt.event.*;
import javax.swing.JPanel.*;
import javax.swing.JLabel.*;
import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JProgressBar;
import java.awt.FlowLayout;
import javax.swing.BoxLayout;
import javax.swing.BoxLayout.*;
import java.awt.geom.Line2D;
import java.awt.geom.Line2D.Double.*;
import java.awt.geom.Line2D.Double;
import java.awt.Rectangle;
import java.awt.Graphics;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;
import javax.swing.JOptionPane.*;
import java.awt.HeadlessException.*;
import javax.swing.JOptionPane;
import javax.swing.JDialog;
import java.awt.*;
import java.lang.String;
/**
 *
 * @author Francisco Olivares
 * @author Cristhoper Jana
 */
public class Resistencia extends Linea implements Cloneable {
    private int resistenciaEnOhm;
    /** Tiene 4 estados, para las resistencias es solo 2:
     *  vertical original  = 1
     *  horizontal normal  = 2
     *  vertical inverso   = 3
     *  horizontal inverso = 4
     */
    private int orientacion = 1;
    /** Creates a new instance of Resistencia */
    public Resistencia() {
        super();
        resistenciaEnOhm = 1;
        orientacion = 1;
    }
    public Resistencia(int valorResistencia) {
        super();
        resistenciaEnOhm = valorResistencia;
        orientacion = 1;
    }
    public Resistencia(int x,int y) {
        super(x,y);
        resistenciaEnOhm = 1;
        orientacion = 1;
    }
    /**
     * DEBE ESTAR DEFINIDO Y UTILIZADO EN CLONE()
     * Define el constructor de Resistencia
     * @param x parametro x de el punto de mas arriba.
     * @param y parametro y de el punto de mas arriba.
     * @param x2 parametro x de el punto de mas abajo.
     * @param y2 parametro y de el punto de mas abajo.
     */
    public Resistencia(int x,int y, int x2, int y2) {
        super(x,y);
        abajoDerecha.setLocation(x2,y2);
        resistenciaEnOhm = 1;
        orientacion = 1;
    }
    public int getValue() {
        return((int)resistenciaEnOhm);
    }
    public void setValue(int value) {
        resistenciaEnOhm = value;
    }
    public int getOrientacion() {
        return(orientacion);
    }
    public void setOrientacion(int value) {
        orientacion = value;
    }
    /**
     * IMPLEMENTAR LA ROTACION,
     * PARA EL CABLE ESTA IMPLEMENTADO.
     */
    public void rotar() {
        orientacion++;
        if(orientacion > 2)
            orientacion = 1;
        switch(orientacion) {
            case 1://vertical, no existen resistencias negativas
                abajoDerecha.setLocation(arribaIzquierda.getX(),
                        arribaIzquierda.getY() + LARGODELASFIGURAS);
                this.mover(LARGODELASFIGURAS / 2, -LARGODELASFIGURAS / 2);                
                break;
            case 2://horizontal, no existen resistencias negativas
                abajoDerecha.setLocation(
                        arribaIzquierda.getX() + LARGODELASFIGURAS,
                        arribaIzquierda.getY());
                this.mover(-LARGODELASFIGURAS / 2, LARGODELASFIGURAS / 2);                
                break;
        }
    }
    public Graphics dibujate(Graphics g) {
        int xa = super.getArribaIzquierdaX();
        int ya = super.getArribaIzquierdaY();
        int xb = super.getAbajoDerechaX();
        int yb = super.getAbajoDerechaY();
        int r  = LARGODELASFIGURAS / 4;
        String text = String.valueOf(Math.round(resistenciaEnOhm));
        text = text.concat("[Ohm]");
        switch(orientacion) {
            case 1:
                g.drawRect(xa-r/2,ya+r,r,2*r);
                g.drawLine(xa,ya,xa,ya+r);
                g.drawLine(xb,yb,xb,yb-r);
                 g.drawString(text,xa+r,ya+2*r+r/2);
                break;
            case 2:
                g.drawRect(xa+r,ya-r/2,2*r,r);
                g.drawLine(xa,ya,xa+r,ya);
                g.drawLine(xb-r,yb,xb,yb);
                g.drawString(text,xa+2*r,ya+r+r/2);
                break;
        }
        return(g);
    }
    public boolean contiene(int x, int y) {
        int xa = super.getArribaIzquierdaX();
        int ya = super.getArribaIzquierdaY();
        int xb = super.getAbajoDerechaX();
        int yb = super.getAbajoDerechaY();
        int r  = LARGODELASFIGURAS / 4;
        Rectangle rectTemp1;
        Rectangle rectTemp2;
        switch(orientacion) {
            case 1:
                rectTemp1 = new Rectangle(
                        xa-ANCHORECTANGULOCAMBIOCOLOR,
                        ya-ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR + LARGODELASFIGURAS);
                rectTemp2 = new Rectangle(
                        xa-r/2-ANCHORECTANGULOCAMBIOCOLOR,
                        ya+r-ANCHORECTANGULOCAMBIOCOLOR,
                        r+2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*r+2*ANCHORECTANGULOCAMBIOCOLOR);
                break;
            case 2:
                rectTemp1 = new Rectangle(
                        xa-ANCHORECTANGULOCAMBIOCOLOR,
                        ya-ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR + LARGODELASFIGURAS,
                        2*ANCHORECTANGULOCAMBIOCOLOR);
                rectTemp2 = new Rectangle(
                        xa+r-ANCHORECTANGULOCAMBIOCOLOR,
                        ya-r/2-ANCHORECTANGULOCAMBIOCOLOR,
                        2*r+2*ANCHORECTANGULOCAMBIOCOLOR,
                        r+2*ANCHORECTANGULOCAMBIOCOLOR);
                break;
            default:
                rectTemp1 = new Rectangle(
                        xa-ANCHORECTANGULOCAMBIOCOLOR,
                        ya-ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR,
                        2*ANCHORECTANGULOCAMBIOCOLOR + LARGODELASFIGURAS);
                rectTemp2 = new Rectangle(
                        xa+r-ANCHORECTANGULOCAMBIOCOLOR,
                        ya-r/2-ANCHORECTANGULOCAMBIOCOLOR,
                        2*r+2*ANCHORECTANGULOCAMBIOCOLOR,
                        r+2*ANCHORECTANGULOCAMBIOCOLOR);
                break;
        }
        return(rectTemp1.contains(x,y) || rectTemp2.contains(x,y));
    }
    /**
     * Metodo que implementa el clone de la clase Lineas.
     * DEBE ESTAR DEFINIDO.
     * @return Objeto que debe ser casteado a cable (identico al entregado),
     *  tipo Object.
     *  Implementado para Resistencia
     */
    public Object clone() {
        Object obj = null;
        obj = new Resistencia(this.getArribaIzquierdaX(),
                           this.getArribaIzquierdaY(),
                           this.getAbajoDerechaX(),
                           this.getAbajoDerechaY());
        ((Linea)obj).cambioDeColor(this.getColor());
        ((Resistencia)obj).setValue(this.getValue());
        ((Resistencia)obj).setOrientacion(this.getOrientacion());
        return(obj);
    }

}
